﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace WebApplication2
{
    public partial class Default : System.Web.UI.Page
    {
        DataSet set;
        protected void Page_Load(object sender, EventArgs e)
        {

            //Create DataSet
            set = new DataSet();
            //Add two tables
            set.Tables.Add(MakeTable("Parent"));
            set.Tables.Add(MakeTableChild("Child"));
            set.Tables.Add(MakeTable2Child("Child2"));

            //Create relations
            DataColumn parentColumn = set.Tables[0].Columns["id"];
            DataColumn childColumn = set.Tables[1].Columns["relation"];
            DataColumn child_p_column = set.Tables[1].Columns["id"];
            DataColumn child2Column = set.Tables[2].Columns["relation"];
            DataRelation relation = new DataRelation("RelationName", parentColumn, childColumn);
            DataRelation relation2 = new DataRelation("RelationName2", child_p_column, child2Column);
            set.Relations.Add(relation);
            set.Relations.Add(relation2);

            WebHierarchicalDataGrid1.DataSource = set;
        }

        /// <summary>
        /// Create a parent table 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        private DataTable MakeTable(string name)
        {
            // Create a new DataTable.
            System.Data.DataTable table = new DataTable(name);
            // Declare variables for DataColumn and DataRow objects.
            DataColumn column;
            DataRow row;

            // Create new DataColumn, set DataType, 
            // ColumnName and add to DataTable.    
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            // Add the Column to the DataColumnCollection.
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Item";
            column.AutoIncrement = false;
            column.Caption = "Item";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Data";
            column.AutoIncrement = false;
            column.Caption = "Data";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);


            // Make the ID column the primary key column.
            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;


            // Create three new DataRow objects and add 
            // them to the DataTable
            for (int i = 0; i <= 20; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = "Item " + i;
                row["Data"] = "Data " + i;
                table.Rows.Add(row);
            }
            return table;

        }

        /// <summary>
        /// Cretae a child table 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        private DataTable MakeTableChild(string name)
        {
            // Create a new DataTable.
            System.Data.DataTable table = new DataTable(name);
            // Declare variables for DataColumn and DataRow objects.
            DataColumn column;
            DataRow row;

            // Create new DataColumn, set DataType, 
            // ColumnName and add to DataTable.    
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            // Add the Column to the DataColumnCollection.
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "relation";
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Item";
            column.AutoIncrement = false;
            column.Caption = "Item";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Data";
            column.AutoIncrement = false;
            column.Caption = "Data";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test1";
            column.AutoIncrement = false;
            column.Caption = "Test1";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test2";
            column.AutoIncrement = false;
            column.Caption = "Test2";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test3";
            column.AutoIncrement = false;
            column.Caption = "Test3";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test4";
            column.AutoIncrement = false;
            column.Caption = "Test4";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test5";
            column.AutoIncrement = false;
            column.Caption = "Test5";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Test6";
            column.AutoIncrement = false;
            column.Caption = "Test6";
            column.ReadOnly = false;
            column.Unique = false;


            // Make the ID column the primary key column.
            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;

            // Create three new DataRow objects and add 
            // them to the DataTable 
            for (int i = 0; i <= 200; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = "Item " + i;
                row["Data"] = "Data " + i;
                row["relation"] = i / 10;

                table.Rows.Add(row);
            }
            return table;

        }

        /// <summary>
        /// Cretae a child table 
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        private DataTable MakeTable2Child(string name)
        {
            // Create a new DataTable.
            System.Data.DataTable table = new DataTable(name);
            // Declare variables for DataColumn and DataRow objects.
            DataColumn column;
            DataRow row;

            // Create new DataColumn, set DataType, 
            // ColumnName and add to DataTable.    
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            // Add the Column to the DataColumnCollection.
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "relation";
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Item";
            column.AutoIncrement = false;
            column.Caption = "Item";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Data";
            column.AutoIncrement = false;
            column.Caption = "Data";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test1";
            column.AutoIncrement = false;
            column.Caption = "Test1";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test2";
            column.AutoIncrement = false;
            column.Caption = "Test2";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test3";
            column.AutoIncrement = false;
            column.Caption = "Test3";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test4";
            column.AutoIncrement = false;
            column.Caption = "Test4";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Guid");
            column.ColumnName = "Test5";
            column.AutoIncrement = false;
            column.Caption = "Test5";
            column.ReadOnly = false;
            column.Unique = false;

            column = new DataColumn();
            column.DataType = System.Type.GetType("System.String");
            column.ColumnName = "Test6";
            column.AutoIncrement = false;
            column.Caption = "Test6";
            column.ReadOnly = false;
            column.Unique = false;


            // Make the ID column the primary key column.
            DataColumn[] PrimaryKeyColumns = new DataColumn[1];
            PrimaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = PrimaryKeyColumns;

            // Create three new DataRow objects and add 
            // them to the DataTable 
            for (int i = 0; i <= 200; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["Item"] = "Item " + i;
                row["Data"] = "Data " + i;
                row["relation"] = i;

                table.Rows.Add(row);
            }
            return table;

        }
    }
}